#!/bin/bash
exec   > >(tee -ia /etc/pki/tpm/tpm.log)
exec  2> >(tee -ia /etc/pki/tpm/tpm.log >& 2)
exec 19> /etc/pki/tpm/tpm.log

export BASH_XTRACEFD="19"
set -x
# variables

nni=$(who | cut -d' ' -f1 | head -n1)
dsp=$(hostname)
out=$(tpm2_getcap handles-persistent)
echo $out | grep -qi "0x81000008"
res=$?

# CLEAN

if [ $res == 0 ]; then

tpm2_evictcontrol -C o -c 0x81000008

else

:

fi

if [ -d "/root/tpm/tmp" ]; then

rm -rf /root/tpm/tmp/tpm2_pkcs11.sqlite3

fi

mkdir -p /root/tpm/tpm2_pkcs11
mkdir -p /root/tpm/tmp

alias tpm2pkcs11-tool='pkcs11-tool --module /usr/lib/x86_64-linux-gnu/libtpm2_pkcs11.so.1'
export TPM2_PKCS11_STORE=/root/tpm/tmp
export TPM2TOOLS_TCTI="device:/dev/tpmrm0"
export TPM2_PKCS11_TCTI="device:/dev/tpmrm0"

tpm2_ptool init
tpm2_ptool addtoken \
        --pid=1 \
        --sopin=0000 \
        --userpin=0000 \
        --label=label
        tpm2_ptool addkey \
        --algorithm=rsa2048 \
        --label=label \
        --userpin=0000
        tpm2_ptool config \
        --key tcti \
        --value "device:/dev/tpmrm0" \
        --label label
TOKEN=`p11tool --list-token-urls | grep "token=label"`
export GNUTLS_PIN=0000
export GNUTLS_SO_PIN=0000
p11tool --login --list-all "${TOKEN}" --outfile p11tool.out
PRIVATE_KEY=`cat p11tool.out | grep private | awk '{ print $2 }'`
SUBJ="/CN=$dsp.postes.calibre.edf.fr"
openssl req \
        -new \
        -engine pkcs11 \
        -keyform engine \
        -key "${PRIVATE_KEY};pin-value=0000" \
        -subj "${SUBJ}" \
        -out $dsp.csr

cp /root/tpm/$dsp.csr /etc/pki/tpm/
